/* 
   Agent Server - AgentServerGUI V1.0, November 12, 2001 

   Written by: 
      Alan Fedoruk                                           -- amf673@mail.usask.ca
      MADMUC Lab                                             -- http://bistrica.usask.ca/madmuc/index.htm
      Dept. of Computer Science, University of Saskatchewan. -- http://www.cs.usask.ca

   Copyright (c) 2001 Alan M. Fedoruk
*/


package agentserver;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;


/** a gui for the AgentServer Agent. Provides a scrollable 
    text area to write messages on. 
*/
public class AgentServerGUI extends JFrame 
{

   private JPanel pane = new JPanel();
   private JTextArea text = new JTextArea( 20,40);
   private String name;
   private AgentServer as = null; 


   /** Constructor
       @param nm  the name of this repserver
       @param r the repserver I was started from
   */
   AgentServerGUI( String nm, AgentServer r) 
   {
      super(nm);
      as =r;
      name = nm;
      initComponents();
      pack();
      setVisible( true);
   } // RepServerGUI()


   /* Set up gui components
   */
   private void initComponents() 
   {
      JScrollPane scrollpane = new JScrollPane( text); 
      pane.add( scrollpane);
      getContentPane().add( pane);
      // add a listener so that shutdown can be called 
      // when the window closes. 
      this.addWindowListener(new WindowAdapter() 
      {
         public void windowClosing(WindowEvent e) 
         {
            if (as != null) 
            {
               as.shutdown();
            }
            System.exit(0);
         }
      });
   } // initComponents()


   /** Write a message to the text box 
   */
   public void write(String message) 
   {
      text.append(message + "\n");
   } // write()


   public static void main ( String args[]) 
   {
      new AgentServerGUI ("test", null).setVisible (true);
   } // main

} // AgentServerGUI

