/* 
   IHELP Simulation - Constants V1.0 

   Written by: 
      Alan Fedoruk                                           -- amf673@mail.usask.ca
      MADMUC Lab                                             -- http://bistrica.usask.ca/madmuc/index.htm
      Dept. of Computer Science, University of Saskatchewan. -- http://www.cs.usask.ca

   Copyright (c) 2001 Alan M. Fedoruk
*/

package ihelp;

/** Constants for use with the I-HELP simulation */
public class IHCONSTANTS {

   public static final int    FIND_TIMEOUT  = 60000;
   public static final String YES           = "YES";
   public static final String NO            = "NO";

   public static final String IHELP_ONT     = "ihelp-ontology";
   public static final String PERSAGENT     = "ihelp-pers-agent"; 
   public static final String UIAGENT       = "ihelp-ui-agent"; 
   public static final String MMAGENT       = "ihelp-mm-agent"; 

   // Keywords
   public static final String JAVA          = "java";
   public static final String DB2           = "db2";
   public static final String ORACLE        = "oracle";
   public static final String PROLOG        = "prolog";
   public static final String PASCAL        = "pascal";
   public static final String UNIX          = "unix";
   public static final String XML           = "xml";
   public static final String FIPA          = "fipaos";

   public static final String[] KEYWORDS    = { JAVA, DB2, ORACLE, PROLOG, PASCAL, UNIX, XML, FIPA };

   // ihelp ontology 
   public static final String REGISTERUI    = "register-ui"; // register a ui agent     : register-ui _user_name
   public static final String KEYWORD_ADD   = "keyword-add"; // add a capability keyword: keyword-add kw0
   public static final String KEYWORD_LIST  = "keyword-list";// respond with a list of keywords: keyword-list
   public static final String FIND          = "find";        // find a helper           : find kw0
   public static final String HELP          = "help";        // request for help        : help person kw0 
   
   public static final String REGISTER      = "register";    // register an agent with a mm : register name id 
   public static final String DEREGISTER    = "de-register"; // de-register an agent with a mm : register
   
   public static final String ONLINE        = "online"; 
   public static final String OFFLINE       = "offline"; 
  
   public static final String[] STATUS        = {ONLINE, OFFLINE};
  
   public static final double FAIL_RATE     = 0.01d;
}
