/* 
   Agent Server - ASCONSTANTS V1.0, November 12, 2001 

   Written by: 
      Alan Fedoruk                                           -- amf673@mail.usask.ca
      MADMUC Lab                                             -- http://bistrica.usask.ca/madmuc/index.htm
      Dept. of Computer Science, University of Saskatchewan. -- http://www.cs.usask.ca

   Copyright (c) 2001 Alan M. Fedoruk
*/


package agentserver; 

/** This class is used as a central repository for constants used 
    by AgentServer and agents that make use of the AgentServer. 

    Conventions similar to those used in  FIPACONSTANTS are used. 
*/
public class ASCONSTANTS 
{
     
   //----------------------------------------------------------------------
   // AgentServer CONSTANTS
   //----------------------------------------------------------------------
	
   public static final String AGENTSERVER_ONT = "agentserver-management"; 
   public static final String AGENTSERVER     = "agentserver"; 

   // AGENTSERVER actions used for repserver-management functions: 

   public static final String PING          = "ping";           // ping this agent server
   public static final String CREATE        = "create-agent";   // create an agent and start it running
   public static final String LIST          = "list-agents";    // list the agents that I have started
   public static final String PROPERTIES    = "properties";     // list my properties

   // TIMEOUTS 

   public static final int    MAX_AGENTS    = 10;  // the default maximum number of agents per repserver 
	
} // End RSCONSTANTS
