/* 
   IHELP Simulation - UIAgentGUI V1.0 

   Written by: 
      Alan Fedoruk                                           -- amf673@mail.usask.ca
      MADMUC Lab                                             -- http://bistrica.usask.ca/madmuc/index.htm
      Dept. of Computer Science, University of Saskatchewan. -- http://www.cs.usask.ca

   Copyright (c) 2001 Alan M. Fedoruk
*/

package ihelp;


import javax.swing.*;


/**
 *
 * @author  Al Fedoruk
 * @version 
 * Created with Forte
 */
public class UIAgentGUI extends JFrame 
{

    private UIAgent _uiagent;
    private String _name; 
    
    /** Creates new form UIAgentGUI */
    public UIAgentGUI( String u, UIAgent ui) 
    {    
        _name = u;
        _uiagent = ui;
        initComponents ();
        setSize(450,550);
        setVisible(true);
        setTitle(_name);
        updateGUI();
    }

    
    /** This methos refreshes all the data in the GUI
    */
    public void updateGUI() 
    {
       txtPersAgent.setText( _uiagent.getPersAgent());
       txtKeywords.setText( _uiagent.getKeywords());
       txtStatus.setText( _uiagent.getStatus());
       // _uiagent.printCounts();
    }


    /** This method is called from within the constructor to
        initialize the form.
        WARNING: Do NOT modify this code. The content of this method is
        always regenerated by the FormEditor.
    */
    private void initComponents() {//GEN-BEGIN:initComponents

       lblPersAgent = new javax.swing.JLabel();
       txtPersAgent = new javax.swing.JTextField();

       lblStatus = new javax.swing.JLabel();
       txtStatus = new javax.swing.JTextField();

       lblKeywords = new javax.swing.JLabel();
       txtKeywords = new javax.swing.JTextField();

       btnFindPersAgent = new javax.swing.JButton();
       btnAddKeyword = new javax.swing.JButton();
       btnFindHelp = new javax.swing.JButton();
       btnStatus = new javax.swing.JButton();
       btnRefresh = new javax.swing.JButton();

       scrResults = new javax.swing.JScrollPane();
       txaResults = new javax.swing.JTextArea();

       scrKeywords = new javax.swing.JScrollPane();
       lstKeywords = new javax.swing.JList();
       lblKeywordsList = new javax.swing.JLabel();

       getContentPane().setLayout(null);
       addWindowListener(new java.awt.event.WindowAdapter() {
             public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
             }
        }
        );
        
        lblPersAgent.setText("Personal Agent");
        lblPersAgent.setForeground(java.awt.Color.black);
        lblPersAgent.setFont(new java.awt.Font ("Dialog", 0, 14));
        getContentPane().add(lblPersAgent);
        lblPersAgent.setLocation(10, 10);
        lblPersAgent.setSize(lblPersAgent.getPreferredSize());
        
        txtPersAgent.setText("jTextField1");
        getContentPane().add(txtPersAgent);
        txtPersAgent.setBounds(30, 30, 130, 30);
        
        lblStatus.setText("Status");
        lblStatus.setForeground(java.awt.Color.black);
        lblStatus.setFont(new java.awt.Font ("Dialog", 0, 14));
        getContentPane().add(lblStatus);
        lblStatus.setLocation(230, 10);
        lblStatus.setSize(lblStatus.getPreferredSize());
        
        // btnAddKeyword
        btnAddKeyword.setLabel("Add Keyword");
        btnAddKeyword.setFont(new java.awt.Font ("Dialog", 0, 10));
        btnAddKeyword.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                mousePressedAddKeyword(evt);
            }
        }
        );
        getContentPane().add(btnAddKeyword);
        btnAddKeyword.setBounds(30, 150, 120, 30);
        
        // btnFindHelp 
        btnFindHelp.setLabel("Find Help");
        btnFindHelp.setFont(new java.awt.Font ("Dialog", 0, 10));
        btnFindHelp.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                mousePressed_FindHelp(evt);
            }
        }
        );
        getContentPane().add(btnFindHelp);
        btnFindHelp.setBounds(30, 190, 120, 30);
        
        // btnFindPersAgent 
        btnFindPersAgent.setLabel("Find PersAgent");
        btnFindPersAgent.setMaximumSize(new java.awt.Dimension(300, 400));
        btnFindPersAgent.setActionCommand("findPersAgent");
        btnFindPersAgent.setFont(new java.awt.Font ("Dialog", 0, 10));
        btnFindPersAgent.setText("FindPersAgent");
        btnFindPersAgent.setMinimumSize(new java.awt.Dimension(300, 400));
        btnFindPersAgent.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                mousePressed_FindPersAgent(evt);
            }
        }
        );
        getContentPane().add(btnFindPersAgent);
        btnFindPersAgent.setBounds(30, 230, 120, 30);
        
        // btnStatus
        btnStatus.setFont(new java.awt.Font ("Dialog", 0, 10));
        btnStatus.setText("Status");
        btnStatus.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                mousePressed_Status(evt);
            }
        }
        );
        getContentPane().add(btnStatus);
        btnStatus.setBounds(30, 270, 120, 30);
        
        // btnRefresh
        btnRefresh.setFont(new java.awt.Font ("Dialog", 0, 10));
        btnRefresh.setText("Refresh");
        btnRefresh.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                mousePressed_Refresh(evt);
            }
        }
        );
        getContentPane().add(btnRefresh);
        btnRefresh.setBounds(30, 310, 120, 30);

        // 
        lblKeywords.setText("Current Keywords");
        lblKeywords.setForeground(java.awt.Color.black);
        lblKeywords.setFont(new java.awt.Font ("Dialog", 0, 14));
        getContentPane().add(lblKeywords);
        lblKeywords.setLocation(10, 70);
        lblKeywords.setSize(lblKeywords.getPreferredSize());
        
        //
        txtKeywords.setText("jTextField1");
        getContentPane().add(txtKeywords);
        txtKeywords.setBounds(30, 100, 360, 30);
        
        // 
        txtStatus.setText("jTextField2");
        getContentPane().add(txtStatus);
        txtStatus.setBounds(250, 30, 130, 30);
        
        //
        scrResults.setViewportView(txaResults);
        getContentPane().add(scrResults);
        scrResults.setBounds(30, 350, 360, 170);
        
        //
        lstKeywords.setListData(IHCONSTANTS.KEYWORDS);
          scrKeywords.setViewportView(lstKeywords);
        getContentPane().add(scrKeywords);
        scrKeywords.setBounds(200, 180, 180, 100);
        
        //
        lblKeywordsList.setText("Keyword Selector");
        lblKeywordsList.setForeground(java.awt.Color.black);
        lblKeywordsList.setFont(new java.awt.Font ("Dialog", 0, 14));
        getContentPane().add(lblKeywordsList);
        lblKeywordsList.setLocation(180, 150);
        lblKeywordsList.setSize(lblKeywords.getPreferredSize());
        
    }//GEN-END:initComponents

  private void mousePressed_Status(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_mousePressed_Status
     _uiagent.switchStatus();
  }//GEN-LAST:event_mousePressed_Status

  private void mousePressed_Refresh(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_mousePressed_Refresh
     updateGUI();
  }//GEN-LAST:event_mousePressed_Refresh

  private void mousePressedAddKeyword(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_mousePressedAddKeyword
    
    String sel = (String)lstKeywords.getSelectedValue();
    if (sel == null) 
    {
        write("Must Select a Keyword\n");
        return;
    }
    
     _uiagent.addKeyword(sel);
  }//GEN-LAST:event_mousePressedAddKeyword

  private void mousePressed_FindHelp(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_mousePressed_FindHelp
       
    String sel = (String)lstKeywords.getSelectedValue();
    if (sel == null) 
    {
        write("Must Select a Keyword\n");
        return;
    }
    write("Starting search for helper to help me with " + sel + "\n");
     _uiagent.findHelp(sel);
  }//GEN-LAST:event_mousePressed_FindHelp

  private void mousePressed_FindPersAgent(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_mousePressed_FindPersAgent
     _uiagent.findPersAgent();
  }//GEN-LAST:event_mousePressed_FindPersAgent

    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_exitForm
        _uiagent.shutdown();
    }//GEN-LAST:event_exitForm

    public void write(String str) 
    {
        txaResults.insert(str,0);
    }

    /**
    * @param args the command line arguments
    */
    public static void main (String args[]) {
        new UIAgentGUI ("test", null).show ();
    }


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel lblPersAgent;
    private javax.swing.JTextField txtPersAgent;

    private javax.swing.JLabel lblStatus;
    private javax.swing.JTextField txtStatus;

    private javax.swing.JLabel lblKeywords;
    private javax.swing.JTextField txtKeywords;

    private javax.swing.JButton btnFindPersAgent;
    private javax.swing.JButton btnAddKeyword;
    private javax.swing.JButton btnFindHelp;
    private javax.swing.JButton btnStatus;
    private javax.swing.JButton btnRefresh;

    private javax.swing.JScrollPane scrResults;
    private javax.swing.JTextArea txaResults;

    private javax.swing.JScrollPane scrKeywords;
    private javax.swing.JList lstKeywords;
    private javax.swing.JLabel lblKeywordsList;

    // End of variables declaration//GEN-END:variables

}
