/* 
   LocalPostOffice V1.1, November 20, 2001  

   Written by: 
      Alan Fedoruk                                           -- amf673@mail.usask.ca
      MADMUC Lab                                             -- http://bistrica.usask.ca/madmuc/index.htm
      Dept. of Computer Science, University of Saskatchewan. -- http://www.cs.usask.ca

   Copyright (c) 2001 Alan M. Fedoruk

   Modifications: 

*/

package localpostoffice;
// Import the fipa-os classes
import fipaos.agent.*;
import fipaos.mts.*;
import fipaos.ont.fipa.*;
import java.util.*;

/** LocalPostOffice implements a local message delivery system. 
    If an agent is running within the same process, this will deliver messages 
    without going outside of the process, providing a performance improvement.
    Requires a slightly modified conversation manager. 
*/
public class LocalPostOffice 
{
   /** List of agents in this process. */
   private Hashtable _started_agents;

   /** Constructor. Set the _started_agents list.  */
   public LocalPostOffice (Hashtable started_agents)
   {
      _started_agents = started_agents; 
   } 

   /** deliver a message. If the receiver is listed in this localpo, 
       then call the receivers receiveMessage directly. Otherwise, 
       throw an exception 
   */
   public void sendMessage( Message msg) throws Exception
   {
      ACL acl = msg.getACL();
      if ( _started_agents.containsKey( acl.getReceiverAID().getName()) ) 
      {
         ((FIPAOSAgent)_started_agents.get( acl.getReceiverAID().getName() )).getCM().receiveMessage(msg);
      }
      else 
      {
         throw new Exception();
      }
   } 
} // LocalPostOffice
