/* 
   Replication Server - RSCONSTANTS V1.0, November 6, 2001 

   Written by: 
      Alan Fedoruk                                           -- amf673@mail.usask.ca
      MADMUC Lab                                             -- http://bistrica.usask.ca/madmuc/index.htm
      Dept. of Computer Science, University of Saskatchewan. -- http://www.cs.usask.ca

   Copyright (c) 2001 Alan M. Fedoruk
*/


package repserver; 

/** This class is used as a central repository for constants used 
    by RepServer and RepAgent classes, such as performative names, 
    ACL fields names etc.

    Conventions similar to those used in  FIPACONSTANTS are used. 
*/
public class RSCONSTANTS 
{
     
   //----------------------------------------------------------------------
   // REPSERVER CONSTANTS
   //----------------------------------------------------------------------
	
   public static final String REPSERVER_ONT = "repserver-management"; 
   public static final String REPSERVER     = "repserver"; 
   public static final String REPPROXY      = "repproxy"; 

   // REPSERVER actions used for repserver-management functions: 

   public static final String REPLICATE     = "replicate";
   public static final String PING          = "ping";
   public static final String LOADSTATE     = "loadstate";
   public static final String REGISTER      = "register"; 
   public static final String ACTIVATE      = "activate"; 
   public static final String STATE         = "state"; 
   public static final String CREATE        = "create"; 

   // ROLES 
 
   public static final String ACTIVE_AGENT  = "active_agent"; 
   public static final String REPLICANT     = "replicant"; 

   // TIMEOUTS 

   public static final int PINGTIMEOUT      = 5000; 
   public static final int GROUPTIMEOUT     = 10000; 
   public static final int PINGWAIT         = 20000; 
	
   public static final int SECONDS_1        = 1000; 
   public static final int SECONDS_2        = 2000; 
   public static final int SECONDS_5        = 5000; 
   public static final int SECONDS_10       = 10000; 
   public static final int SECONDS_30       = 30000; 
   public static final int MINUTES_1        = 60000; 

   public static final int STATES           = 10; 

   // Replication Types 

   public static final String HOT_STANDBY	= "hot-standby";
   public static final String COLD_STANDBY	= "cold-standby";
    
	
} // End RSCONSTANTS
	
