/* 
   Test Replication Server - CountAgentGUI V1.0, November 6, 2001 

   Written by: 
      Alan Fedoruk                                           -- amf673@mail.usask.ca
      MADMUC Lab                                             -- http://bistrica.usask.ca/madmuc/index.htm
      Dept. of Computer Science, University of Saskatchewan. -- http://www.cs.usask.ca

   Copyright (c) 2001 Alan M. Fedoruk
*/

package testRS;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;


public class CountAgentGUI extends JFrame {

   private JPanel pane = new JPanel();
   private JTextArea text = new JTextArea( 10,40);
   private String name;
   private CountAgent parent = null;


   public CountAgentGUI( String nm) {

      super(nm);
      name = nm;
      initComponents();
      pack();
      setVisible( true);

   } // ReqAgentGUI()

   public CountAgentGUI( String nm, CountAgent p) {

      super(nm);
      parent = p;
      name = nm;
      initComponents();
      pack();
      setVisible( true);

   } // ReqAgentGUI()



   private void initComponents() {

      JScrollPane scrollpane = new JScrollPane( text); 
      pane.add( scrollpane);
      getContentPane().add( pane);

      this.addWindowListener(new WindowAdapter() {
         public void windowClosing(WindowEvent e) {
         if (parent != null) {
            parent.shutdown();
         }
      }
      });


   } // initComponents()


   /** 
    *  Write a message to the text box 
    *
    */
   public void write(String message) {

      text.append(message + "\n");

   } // write()


   public static void main ( String args[]) {

      new CountAgentGUI ("test").setVisible (true);

   } // main

} // AgentGUI

